Fixed two typos.
[rsync/rsync.git] / testsuite / rsync.fns
CommitLineData
d820215b
MP
1#! /bin/sh
2
3# Copyright (C) 2001 by Martin Pool <mbp@samba.org>
4
5# General-purpose test functions for rsync.
3a4c683f 6
0154b302
MP
7# This program is free software; you can redistribute it and/or modify
8# it under the terms of the GNU General Public License version
9# 2 as published by the Free Software Foundation.
10#
11# This program is distributed in the hope that it will be useful, but
12# WITHOUT ANY WARRANTY; without even the implied warranty of
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
14# Lesser General Public License for more details.
15#
16# You should have received a copy of the GNU Lesser General Public
17# License along with this program; if not, write to the Free Software
18# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
19
20
6f481bb0 21tmpdir="$scratchdir"
e3442095
WD
22fromdir="$tmpdir/from"
23todir="$tmpdir/to"
24chkdir="$tmpdir/chk"
3a4c683f 25
2094283b 26# Berkley's nice.
96553aa7 27PATH="$PATH:/usr/ucb"
2094283b 28
e3442095 29if diff -u "$srcdir/testsuite/rsync.fns" "$srcdir/testsuite/rsync.fns" >/dev/null 2>&1; then
84229c7a
WD
30 diffopt="-u"
31else
32 diffopt="-c"
33fi
34
3a4c683f
MP
35runtest() {
36 echo $ECHO_N "Test $1: $ECHO_C"
501972bf
MP
37 if eval "$2"
38 then
6f481bb0 39 echo "$ECHO_T done."
501972bf
MP
40 return 0
41 else
6f481bb0 42 echo "$ECHO_T failed!"
501972bf
MP
43 return 1
44 fi
3a4c683f
MP
45}
46
47printmsg() {
48 echo "$1"
49}
50
e052b21f 51
6773a779 52rsync_ls_lR() {
22558cdd 53 find "$@" -print | sort | sed 's/ /\\ /g' | xargs "$TOOLDIR/tls"
dfef3f10
MP
54}
55
56rsync_getgroups() {
57 "$TOOLDIR/getgroups"
57835c00
MP
58}
59
60
e052b21f 61####################
6f481bb0 62# Build test directories $todir and $fromdir, with $fromdir full of files.
e052b21f 63
3a4c683f 64hands_setup() {
501972bf 65 # Clean before creation
6f481bb0
WD
66 rm -rf "$fromdir"
67 rm -rf "$todir"
3d807132 68
e3442095
WD
69 [ -d "$tmpdir" ] || mkdir "$tmpdir"
70 [ -d "$fromdir" ] || mkdir "$fromdir"
71 [ -d "$todir" ] || mkdir "$todir"
3a4c683f 72
e052b21f
MP
73 # On some BSD systems, the umask affects the mode of created
74 # symlinks, even though the mode apparently has no effect on how
75 # the links behave in the future, and it cannot be changed using
76 # chmod! rsync always sets its umask to 000 so that it can
77 # accurately recreate permissions, but this script is probably run
78 # with a different umask.
79
80 # This causes a little problem that "ls -l" of the two will not be
81 # the same. So, we need to set our umask before doing any creations.
82
3a4c683f 83 # set up test data
6f481bb0
WD
84 touch "$fromdir/empty"
85 mkdir "$fromdir/emptydir"
e8ca5901 86
571a4b26 87 # a hundred lines of text or so
6f481bb0 88 rsync_ls_lR "$srcdir" > "$fromdir/filelist"
3a4c683f 89
6f481bb0 90 echo $ECHO_N "This file has no trailing lf$ECHO_C" > "$fromdir/nolf"
0154b302 91 umask 0
6f481bb0 92 ln -s nolf "$fromdir/nolf-symlink"
4c80c473 93 umask 022
0154b302 94
db10766a 95 cat "$srcdir"/*.c > "$fromdir/text"
6f481bb0
WD
96 mkdir "$fromdir/dir"
97 cp "$fromdir/text" "$fromdir/dir"
98 mkdir "$fromdir/dir/subdir"
99 echo some data > "$fromdir/dir/subdir/foobar.baz"
100 mkdir "$fromdir/dir/subdir/subsubdir"
a7a1cc2c
WD
101 if [ -r /etc ]; then
102 ls -ltr /etc > "$fromdir/dir/subdir/subsubdir/etc-ltr-list"
103 else
104 ls -ltr / > "$fromdir/dir/subdir/subsubdir/etc-ltr-list"
105 fi
6f481bb0 106 mkdir "$fromdir/dir/subdir/subsubdir2"
a7a1cc2c
WD
107 if [ -r /bin ]; then
108 ls -lt /bin > "$fromdir/dir/subdir/subsubdir2/bin-lt-list"
109 else
110 ls -lt / > "$fromdir/dir/subdir/subsubdir2/bin-lt-list"
111 fi
7d691654 112
8f98c608 113# echo testing head:
6f481bb0 114# ls -lR "$srcdir" | head -10 || echo failed
3a4c683f 115}
3fedd74b
MP
116
117
99cdaff7
MP
118####################
119# Many machines do not have "mkdir -p", so we have to build up long paths.
120# How boring.
121makepath () {
7c1b7890 122 echo " makepath $1"
99cdaff7
MP
123 p="$1"
124 (
125 # Absolut Unix.
126 if echo $p | grep '^/' >/dev/null
127 then
128 cd /
129 fi
130
131 # This will break if $1 contains a space.
132 for c in `echo $p | tr '/' ' '`
133 do
112e7311
MP
134 if [ -d "$c" ] || mkdir "$c"
135 then
136 cd "$c" || return $?
137 else
138 echo "failed to create $c" >&2; return $?
139 fi
99cdaff7
MP
140 done
141 )
142}
143
144
145
3fedd74b
MP
146###########################
147# Run a test (in '$1') then compare directories $2 and $3 to see if
148# there are any difference. If there are, explain them.
149
f494f286
MP
150# So normally basically $1 should be an rsync command, and $2 and $3
151# the source and destination directories. This is only good when you
152# expect to transfer the whole directory exactly as is. If some files
153# should be excluded, you might need to use something else.
154
3fedd74b 155checkit() {
3fedd74b 156 failed=
3fedd74b 157
cf72f204
MP
158 # We can just write everything to stdout/stderr, because the
159 # wrapper hides it unless there is a problem.
160
161 echo "Running: \"$1\""
162 eval "$1"
3fedd74b
MP
163 status=$?
164 if [ $status != 0 ]; then
165 failed="YES";
166 fi
167
cf72f204
MP
168 echo "-------------"
169 echo "check how the directory listings compare with diff:"
170 echo ""
6f481bb0
WD
171 ( cd "$2" && rsync_ls_lR . ) > "$tmpdir/ls-from"
172 ( cd "$3" && rsync_ls_lR . ) > "$tmpdir/ls-to"
173 diff $diffopt "$tmpdir/ls-from" "$tmpdir/ls-to" || failed=YES
30688bf1
WD
174
175 echo "-------------"
176 echo "check how the files compare with diff:"
177 echo ""
178 if [ "x$4" != x ]; then
179 echo " === Skipping (as directed) ==="
180 else
181 diff -r $diffopt "$2" "$3" || failed=YES
182 fi
183
184 echo "-------------"
6f481bb0 185 if [ -z "$failed" ] ; then
3fedd74b
MP
186 return 0
187 else
3fedd74b
MP
188 return 1
189 fi
190}
191
863dff51 192
4a7cb3e8 193build_rsyncd_conf() {
d2094cc3
MP
194 # Build an appropriate configuration file
195 conf="$scratchdir/test-rsyncd.conf"
196 echo "building configuration $conf"
197
198 port=2612
199 pidfile="$scratchdir/rsyncd.pid"
200 logfile="$scratchdir/rsyncd.log"
201
6f481bb0 202 cat >"$conf" <<EOF
3aae15ec 203# rsyncd configuration file autogenerated by $0
d2094cc3 204
3aae15ec
MP
205pid file = $pidfile
206use chroot = no
207hosts allow = localhost, 127.0.0.1
208log file = $logfile
6f481bb0 209exclude = foobar.baz
eddeaf76 210max verbosity = 9
d2094cc3 211
76ee1d18
WD
212uid = 0
213gid = 0
98c1b325 214
2e6c7f45 215[test-from]
6f481bb0 216 path = $fromdir
3aae15ec 217 read only = yes
d2094cc3 218
2e6c7f45 219[test-to]
6f481bb0 220 path = $todir
3aae15ec 221 read only = no
d2094cc3
MP
222EOF
223}
224
225
3cd2af41 226build_symlinks() {
3cd2af41
MP
227 mkdir "$fromdir"
228 date >"$fromdir/referent"
229 ln -s referent "$fromdir/relative"
230 ln -s "$fromdir/referent" "$fromdir/absolute"
231 ln -s nonexistent "$fromdir/dangling"
1db8b61d 232 ln -s "$srcdir/rsync.c" "$fromdir/unsafe"
3cd2af41
MP
233}
234
235test_fail() {
236 echo "$@" >&2
237 exit 1
238}
239
a217ad30
MP
240test_skipped() {
241 echo "$@" >&2
6f481bb0 242 echo "$@" > "$tmpdir/whyskipped"
a217ad30
MP
243 exit 77
244}
245
be2f866b
MP
246# It failed, but we expected that. don't dump out error logs,
247# because most users won't want to see them. But do leave
248# the working directory around.
249test_xfail() {
250 echo "$@" >&2
251 exit 78
252}
253
d1239eae
MP
254# Determine what shell command will appropriately test for links.
255ln -s foo "$scratchdir/testlink"
256for cmd in test /bin/test /usr/bin/test /usr/ucb/bin/test /usr/ucb/test
257do
258 for switch in -h -L
259 do
260 if $cmd $switch "$scratchdir/testlink" 2>/dev/null
261 then
262 # how nice
263 TEST_SYMLINK_CMD="$cmd $switch"
264 # i wonder if break 2 is portable?
265 break 2
266 fi
267 done
268done
cca4e067
MP
269# ok, now get rid of it
270rm "$scratchdir/testlink"
d1239eae
MP
271
272
273if [ "x$TEST_SYMLINK_CMD" = 'x' ]
274then
275 test_fail "Couldn't determine how to test for symlinks"
276else
277 echo "Testing for symlinks using '$TEST_SYMLINK_CMD'"
278fi
279
280
d96d3893
MP
281# Test whether something is a link, allowing for shell peculiarities
282is_a_link() {
d1239eae
MP
283 # note the variable contains the first option and therefore is not quoted
284 $TEST_SYMLINK_CMD "$1"
d96d3893
MP
285}
286
77867907
MP
287
288# We need to set the umask to be reproducible. Note also that when we
289# do some daemon tests as root, we will setuid() and therefore the
290# directory has to be writable by the nobody user in some cases. The
291# best thing is probably to explicitly chmod those directories after
292# creation.
293
ad301e48 294umask 022